<?php
/*
* mod_dashboardbuilder Our Joomla module of dashboard builder provides you with the ability to connect any MySQL database such as  Virtuemart, K2, JoomShopping, HikaShop, EShopand or any other database even outside of Joomla and create fully responsive, D3.js based dynamic line charts for you. Our Pro version of Dashboard Builder supports variety of charts such as line, scatter, bar, pie, donuts, bubble, stack, area, heatmap, sankey diagrams and choropleth map. for more information visit https://dashboardbuilder.net 
* @copyright (c) Copyright: Dashboard Builder, https://dashboardbuilder.net
* @author support@dashboardbuilder.net 
* @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
* @date Nov 26, 2018
* @package Joomla 3.x
*/

// no direct access
defined('_JEXEC') or die('Restricted access');
if(!defined('DS')){
   define('DS',DIRECTORY_SEPARATOR);
}

$mod_url = "modules/mod_dashboardbuilder";

$doc = JFactory::getDocument();

include($mod_url."/assets/inc/dashboard_dist.php");  // copy this file to inc folder 
$doc->addCustomTag('<script src="'.$mod_url.'/assets/js/dashboard.min.js" type="text/javascript"></script>');
$data = new dashboardbuilder(); 

// mod_dashboardbuilder version
$ver = '1.0';
$xaxis = array();
$yaxis = array();
$fileupload = false;

if ($params->get('datasource')==2) { // if Database
	$data->source =  "Database"; 
	$data->rdbms =  "mysql"; 
	$data->servername =  $params->get( 'host' );
	$data->username =  $params->get( 'user' );
	$data->password =  $params->get( 'password' );
	$data->dbname =  $params->get( 'dbname' );
	
	
	
} else { // if XLS file
	if ($params->get('filename') < 0) {
			JFactory::getApplication()->enqueueMessage('No file selected', 'error');
			return;
	} else {
		//
		$fileupload = true;
		require_once dirname(__FILE__).DS.'inc'.DS.'excel_reader2.php';
		require_once dirname(__FILE__).DS.'inc'.DS.'SpreadsheetReader.php';
		$filename = $params->get('filename');
		$filename = 'modules'.DS.'mod_dashboardbuilder'.DS.'data'.DS.$filename;

		$Reader = new SpreadsheetReader($filename);
		$i=0;
		
		
		$XLSCol = array();
		foreach ($Reader as $XLS)
			{
			 
				$j=0;
				foreach ($XLS as $HDS)
					{
						$HDS = str_replace(array(","), '~', $HDS);  // newly added
						$XLSCol[$j][$i] = $HDS;
						//echo $HDS;
						$j++;
					}
				$i++;
			}
		
	}
}


$repeated_field = (array)$params->get('repeated-field');

$xtitle = $params->get( 'xtitle' );
$ytitle = $params->get( 'ytitle' );



// for chart #1


$i=0;
foreach($repeated_field as $item) {

	if ($fileupload) {
			$k=0;
		foreach ($XLSCol as $key)
			{
				if ($XLSCol[$k][0]==$item->xaxis) {
					$data->xaxis[$i] = implode (',',array_slice($XLSCol[$k], 1));		
				}
				if ($XLSCol[$k][0]==$item->yaxis) {
					$data->yaxis[$i] = implode (',',array_slice($XLSCol[$k], 1));
				}
				$k++;
			} 
			
			$a = array_map('strval', explode(',', $data->xaxis[$i]));
			$data->xaxis[$i] = $a;
			
			$a = array_map('strval', explode(',', $data->yaxis[$i]));
			$data->yaxis[$i] = $a;
			
	} else {
		$data->xaxisSQL[$i]=  $params->get( 'sql' );
		$data->xaxisCol[$i]=  $item->xaxis;
		$data->yaxisSQL[$i]=  $params->get( 'sql' );
		$data->yaxisCol[$i]=  $item->yaxis;
	}
	
	$data->type[$i]=  $item->charttype;
	$data->color[$i]=  $item->color;
	$data->tracename[$i]=  $item->tracename;
	$i++;
}

$data->name = "0";
$data->orientation = $params->get('orientation');
$data->xaxistitle = $xtitle;
$data->yaxistitle = $ytitle;
$data->showgrid = "true";
$data->showline = "true";
$data->height = $params->get('height');
$data->width = $params->get('width');
$data->col = "0";

echo $data->result();?>